;Mkxtab.sc - Creates Crosstab.lib that contains the procedures for the 
;            Cross-Tabulation Utility to be used with Paradox Release 2.xx.

;Contains Licensed Material Copyright (c) Borland International, 1985 - 1988
;All Rights Reserved

CURSOR OFF


PROC Msg (MsgText, Dots)								 			; Display a message
	PRIVATE column

	CURSOR OFF
   
	IF (Dots)
		THEN column = 80 - LEN (" " + MsgText + " ... ")
		ELSE column = 80 - LEN (" " + MsgText + " ")
	ENDIF
	column = MAX (column, 0)
	line   = 22
   @ line, 0 CLEAR EOL
   STYLE REVERSE
   @ line, column ??  " " + MsgText + " "
	IF (Dots)
		THEN STYLE REVERSE, BLINK
			  ??  "..."
			  STYLE REVERSE
			  ??  " "
	ENDIF
	STYLE

ENDPROC     									; End Msg (MsgText, Dots)


Msg ("Creating the 20xtab Library", TRUE)


PROC Main ()							; The Main proc of Cross Tab

	CrosstabSplashScreen ()
	Startup ()
	RELEASE PROCS 	CrosstabSplashScreen, Startup

	Qry (labelfield, valuefield)
	Transform (labelfield, valuefield)

ENDPROC									; End Main ()


PROC CrosstabSplashScreen ()      ; Display the Crosstab splash screen
  CLEAR
  @ 0, 0
TEXT

    
    ߱
              B O R L A N D    I N T E R N A T I O N A L         
    ܰ
    
    
    ͱ
                                                                   
                                                                     
    ͱ
    
    ߰
             P   A   R   A   D   O   X          
     
        C r o s s t a b   G e n e r a t o r     
     
                                           
    
    
    
                                 Release 2.01
  Contains Licensed Material Copyright (C) Borland International, 1985 - 1988
                              All Rights Reserved
    June 20, 1988
  ENDTEXT

  SLEEP 2000

ENDPROC              ; End CrosstabSplashScreen


PROC help2 ()            ; Help screen when running Paradox 2.0 or higher.

  @ 0, 0
  TEXT
Ŀ
               Instructions for constructing a cross tabulation:              
                              
 [F1] - This information screen.                                              
 [F2] - When you are done, Do-It!                                             
 [F5] - You may use examples to link 2 or more fields. None of your examples  
        may be the words "Label" or "Value" in any upper/lower case spelling. 
 [F6] - Check the grouping fields, i.e., the fields in this table which will  
        be used to group the records in the cross-tab table.  (These fields   
        will appear in the cross-tab table as they are in this one and, thus, 
        may be considered as the unchanged or constant fields.)               
 [Alt-F6] - Similar to [F6] except for it checks the grouping fields with a   
            Check-Plus ( + ).                                                
 [F10] - Activate the menu for selecting the Label and Value fields.  As you  
         make your selection you will see the appropriate marker placed in    
         the field you have just selected.  You can always change your mind.  
         As the Label field must be checkmarked and the Value field may not,  
         a checkmark is automatically placed or removed from the field accor- 
         ding to your selection.  Since Paradox limits the number of fields   
         in a table to 255, you must be certain that the number of unique     
         values in the Label fields plus the number of the Grouping fields is 
         no larger than 255. Calculation may be entered in the Value field.   
 Note:   This query may contain only a single line.                           

  ENDTEXT

  STYLE REVERSE
  @ 12, 26 ?? "+"
 STYLE


  Msg ("Press any key when done", TRUE)
  c = getchar ()

endproc


PROC  VerifyExample (exampletype, theexample, fieldname)

  CTRLHOME
  FOR i FROM 1 TO numoffields
      RIGHT
      IF (LEN ([]) > 4 AND SUBSTR ([], 1, 5) = theexample)
         THEN Msg ("Only one " + exampletype + "-Field marker is "    +
                                     "allowed per table!", FALSE)
              EXECUTE "MOVETO [" + fieldname + "]"
              RETURN TRUE
      ENDIF
  ENDFOR

   EXECUTE "MOVETO [" + fieldname + "]"
   RETURN FALSE

ENDPROC							      ; End VerifyExample ()


PROC UseSetup2 ()       ; Setup procedure for Paradox release 2.0 or higher

  tableprompt = "The table to be cross-tabulated: "

  WHILE (TRUE)
    @ 1, 0 CLEAR EOL ?? "Enter name of table to be cross-tabulated, "   +
                               "or press  to see a list of tables."
    @ 0, 0 CLEAR EOL ?? tableprompt

    CURSOR BOX

    ACCEPT "A46"
      PICTURE "{&,#,~,;!,;@,;#,$,%,;&,_,;\\}"  +
           "*{?,#,~,;!,;@,;#,$,%,;&,_,-,;\\,:}"
      DEFAULT sourcetable
      TO sourcetable

      CURSOR OFF
      SWITCH
        CASE Retval = FALSE   : QUIT
        CASE sourcetable = "" :
             @ 22, 0 CLEAR EOL
             @ 23, 0 ?? "Use - and - keys to move around menu, "  +
                                "then press  to make selection."
             SHOWTABLES "" tableprompt to sourcetable
             SWITCH
               CASE sourcetable = "None" : QUIT "There are no tables in " +
                                                        "this directory!"
               CASE sourcetable = "Esc"  : QUIT
             ENDSWITCH
      ENDSWITCH

      IF (ISTABLE (sourcetable))
         THEN IF (ISEMPTY (sourcetable))
                 THEN MESSAGE "Table " + sourcetable + " is empty!"
                      SLEEP 2000
                      sourcetable = ""
                      LOOP
                 ELSE STYLE
                      QUITLOOP
              ENDIF
         ELSE MESSAGE "Cannot find " + sourcetable + "!"
              SLEEP 2000
              sourcetable = ""
              LOOP
      ENDIF
  ENDWHILE

  numoffields = NFIELDS (sourcetable)

  CLEAR
  CLEARALL
  {Ask} SELECT SourceTable

  ARRAY LabelFields  [NumOfFields]
  array LabelPrompts [NumOfFields]
  array ValueFields  [NumOfFields]
  array ValuePrompts [NumOfFields]

  FOR i FROM 1 TO NumOfFields
      RIGHT
      LabelFields  [i] = field()
      ValueFields  [i] = field()
      LabelPrompts [i] = ""
      ValuePrompts [i] = ""
  ENDFOR
  CTRLHOME

  LabelField0 = ""
  ValueField0 = ""
  LabelField  = ""
  ValueField  = ""

  FillInQry2 ()

ENDPROC                  						 ; End UseSetup2 ()


PROC FillInQry2 ()         ; Lets user fill in the query form in Paradox2.
	PRIVATE warning1, warning2, warning3,
			  notice1, notic2, notice3, notice

	warning1 = FORMAT ("W80,AC",
				  "At least one grouping field must be checkmarked!")
	warning2 = FORMAT ("W80,AC",
  				  "There must be one Label Field and it must be checkmarked!")
	warning3 = FORMAT ("W80,AC",
  				  "There must be one Value Field and it may not be checkmarked!")

	WHILE (TRUE)

   	WAIT RECORD
      	PROMPT "[F1] - Help; [F2] - Do-It!; [F5] - Example; [F6] - Check; [Alt-F6] - Check Plus;",
         		 "[F10] - Menu; [Esc] - quit. WARNING: DON'T USE \"LABEL\" or \"VALUE\" AS AN EXAMPLE!"
			UNTIL  "F1", "F2", "F6", "F36", "F10", "Esc"

		SWITCH
      	CASE Retval = "F1" :
				help2()
				LOOP
			CASE Retval = "F2" :
				Menu
				IF (MENUCHOICE () = "Error")
            	THEN MESSAGE WINDOW ()
               	  SLEEP 2000
						  LOOP
               ELSE ESC
				ENDIF
				LabelField = ""
				ValueField = ""
				notice1 = warning1
				notice2 = warning2
				notice3 = warning3
				notice = ""
				NumOfGroups = 0
				CTRLHOME
				IF ([] <> "")
            	THEN MESSAGE "The # Field must be empty!"
               	  SLEEP 2000
				ENDIF
				FOR i FROM 1 TO NumOfFields
            	RIGHT
					IF (CHECKMARKSTATUS () <> ""       AND
               	 SUBSTR ([], 1, 7) <> "_Label!" AND
						 SUBSTR ([], 1, 7) <> "_Value!")
						THEN notice1 = ""
                  	  NumOfGroups = NumOfGroups + 1
							  LOOP
					ENDIF
					IF (SUBSTR ([], 1, 7) = "_Label!" AND CHECKMARKSTATUS () <>"")
               	THEN LabelField = FIELD ()
                  	  notice2 = ""
							  LOOP
					ENDIF
					IF (SUBSTR ([], 1, 7) = "_Value!" AND CHECKMARKSTATUS () = "")
               	THEN ValueField = FIELD ()
                  	  notice3 = ""
							  IF ([] = "_Value!")
                       	  THEN CHECK
							  ENDIF
               ENDIF
				ENDFOR
				CTRLHOME
				notice = notice1 + notice2 + notice3
				IF (notice = "")
         		THEN IF (LabelFieldOK ())
						  	  THEN RETURN
						  ENDIF
					ELSE MESSAGE SUBSTR (notice, 2, LEN (notice)-2)
                        	 ; The SUBSTR is necessary for MESSAGE flanks the content string with a blank space.
						  SLEEP LEN (notice) * 30
						  LOOP
            ENDIF
			CASE Retval = "F6" :
				CHECK
			CASE Retval = "F36" :
				CHECKPLUS
			CASE Retval = "F10" :
				SHOWMENU
            	"Label-Field Selection" :
						"Select the Label Field.",
					"Value-Field Selection" :
						"Select the Value field."
					TO FldSlct

				SWITCH
            	CASE FldSlct = "Label-Field Selection" :
               	SHOWARRAY LabelFields LabelPrompts
                  	TO LabelField0
						IF (LabelField0 = "Esc")
                  	THEN LOOP
						ENDIF
						IF (LabelField <> "")
                  	THEN CleanField (LabelField, "L")
						ENDIF
						MOVETO FIELD LabelField0
						LabelField = LabelField0
						SWITCH
							CASE CHECKMARKSTATUS () = "":
								CHECK
							CASE CHECKMARKSTATUS () = "CheckPlus" :
								CHECK
								CHECK
						ENDSWITCH
						[] = "_Label!"
						LOOP
					CASE FldSlct = "Value-Field Selection" :
               	SHOWARRAY ValueFields ValuePrompts
                  	TO ValueField0
						IF (ValueField0 = "Esc")
                  	THEN LOOP
						ENDIF
						IF (ValueField <> "")
                  	THEN CleanField (ValueField, "V")
						ENDIF
						MOVETO FIELD ValueField0
						ValueField = ValueField0
						ECHO NORMAL
						[] = "_Value!"
						IF (CHECKMARKSTATUS () <> "")
                  	THEN CHECK
						ENDIF
						ECHO OFF
						popup (31,7)
						LOOP
					CASE FldSlct = "Esc" :
               	LOOP
            ENDSWITCH
			CASE Retval = "Esc" :
				CLEAR
				SHOWMENU
         		"No"  :
						"Do not leave the Crosstab Generator.",
					"Yes" :
						"Leave the Crosstab Generator and return to Paradox main menu."
					TO ExitOrNot

				SWITCH
            	CASE ExitOrNot = "No"  :
						LOOP
               CASE ExitOrNot = "Yes" :
						CLEARALL
                  QUIT
            ENDSWITCH
			OTHERWISE :
				BEEP
		ENDSWITCH
	ENDWHILE
	CLEAR

ENDPROC                            ; End FillInQry2 ()


PROC LabelFieldOK ()						; Verify that there are no blank entries
	PRIVATE BlanksInLabelField			; in the Label Field

   Menu {Scripts} {QuerySave} {Zzz$$zzz}
	IF (MENUCHOICE () = "Cancel")
		THEN {Replace}
	ENDIF
	CLEARALL
	{Ask} SELECT sourcetable
		CHECK
		EXECUTE "MOVETO [" + LabelField + "]"
		"BLANK"
	DO_IT!
	IF (NOT ISEMPTY ("Answer"))
	 	THEN MESSAGE "The Label Field may not contain any blank entry!"
			  BlanksInLabelField = TRUE
			  SLEEP 2500
		ELSE BlanksInLabelField = FALSE
	ENDIF
	Menu {Tools} {Delete} {Table} {Answer} {OK}
	Play "Zzz$$zzz"
	{Tools} {Delete} {Script} {Zzz$$zzz} {OK}

	IF (BlanksInLabelField)
		THEN RETURN FALSE
		ELSE RETURN TRUE
	ENDIF

ENDPROC									; End LabelFieldOK ()



PROC CleanField (ThisField, Mark)  ; Removes marker if user places it elsewhere
  CURSOR OFF
  MOVETO FIELD ThisField
  ECHO NORMAL
  if (ThisField <> "")
     then switch
            case Mark = "L" : if (substr ([], 1, 7) = "_Label!")
                                 then [] = ""
                                      if (CHECKMARKSTATUS () <> "")
                                         then Check
                                      endif
                              endif
            case Mark = "V" : if (substr ([], 1, 7) = "_Value!")
                                 THEN [] = ""
                              ENDIF
          ENDSWITCH
  ENDIF
  ECHO OFF

ENDPROC                            ; End CleanField (ThisField)


PROC Startup ()                    ; Startup: select a setup procedure

  CLEAR
  STYLE REVERSE
  @ 6, 0 ?? FORMAT ("W80,AC", "Paradox Cross Tabulation")
  STYLE

  @ 8, 0
  TEXT
The Crosstab Generator  cross tabulates a specified table.   To do so you need
to specify the "grouping" field(s), the "label" field and the "value" field in
the original table.  The "Grouping" fields remain  unchanged during the trans-
formation; the cross tabulated values are grouped on these fields. The "Label"
field is the one whose entries become field names in the cross-tab table.  The
"Value" field is the field whose entries become the entries in the fields that
were created from the entries in the "Label" field.








[Esc] to cancel and return to Paradox main menu.
  ENDTEXT

  sourcetable = ""
  UseSetup2 ()
  CLEAR

ENDPROC                 						; End Startup ()


PROC Transform (labelfield, valuefield)   ; Transform the Anser table of the
	PRIVATE numoffields                    ; original query to the cross-tab
                                          ; table.
	CLEARALL
	VIEW "$zzzxtab"
	IF (NFIELDS ("$zzzxtab") > 2)
		THEN numoffields = NFIELDS ("$zzzxtab")
			CTRLEND
			MENU {Image} {Move} SELECT labelfield ENTER
			MENU {Image} {Move} SELECT valfld ENTER
	ENDIF

	CTRLHOME

	ARRAY groupfield [NumOfGroups]
	ARRAY groupvalue [NumOfGroups]
	j = 0
	FOR i FROM 1 TO numofgroups
   	RIGHT
		IF (FIELD () <> labelfield  AND  FIELD () <> valuefield)
      	THEN j = j + 1
				groupfield [j] = FIELD ()
				groupvalue [j] = ""
		ENDIF
	ENDFOR

  CTRLEND
  calcfield = FIELD ()

  VIEW "$$zzxtab"
  EDITKEY

  UPIMAGE
  SCAN FOR TRUE
    CTRLHOME
    FOR i from 1 to numofgroups
        RIGHT
        groupvalue [i] = []
    ENDFOR

    RIGHT
    IF (FIELD () = LabelField)
       THEN IF (SUBSTR (TYPE ([]), 1, 1) = "A")
               THEN FieldLabel = []
               ELSE FieldLabel = STRVAL ([])
            ENDIF
       ELSE QUIT "Error: Can't locate Label field in the temporary table!"
    ENDIF

    RIGHT
    IF (FIELD () = calcfield)
       THEN targetvalue = []
       ELSE QUIT "Error: Can't locate calculated field in the temporary table!"
    ENDIF

    DOWNIMAGE
    FIRSTSHOW
    HOME
    CTRLHOME
    RIGHT
    SCAN FOR ([] = groupvalue [1])
       QUITLOOP
    ENDSCAN
    FOR i FROM 1 TO numofgroups
        abortloop = FALSE
        loopagain = FALSE
        EXECUTE "MOVETO [" + groupfield [i] + "]"
        IF (ISBLANK ([]))
           THEN [] = groupvalue [i]
           ELSE IF ([] <> groupvalue [i])
                   THEN thisrec = recno()
                        SCAN FOR (RECNO () >= thisrec AND
                                   ([] = groupvalue [i] OR ISBLANK ([])))
                             IF ([] = groupvalue [i])
                                THEN IF (i = numofgroups)
                                        THEN abortloop = TRUE
                                        ELSE loopagain = TRUE
                                     ENDIF
                                ELSE UP
                             ENDIF
                             QUITLOOP
                        ENDSCAN
                        SWITCH
                           CASE abortloop = TRUE : QUITLOOP
                           CASE loopagain = TRUE : LOOP
                        ENDSWITCH
                        DOWN
                        CTRLHOME
                        FOR j FROM 1 TO i
                            RIGHT
                            [] = groupvalue [j]
                        ENDFOR
                ENDIF
                IF (i = numofgroups)
                   THEN QUITLOOP
                   ELSE LOOP
                ENDIF
        ENDIF
    ENDFOR

    EXECUTE "MOVETO [" + FieldLabel + "]"
    IF (NOT ISBLANK ([]))
       THEN CTRLHOME
            IF (ATLAST ())
               THEN DOWN      ; Will get into trouble in record before last if
                    CTRLHOME  ; combine the 2 "down" into 1 before the "if".
               ELSE DOWN
                    INS
            ENDIF
            FOR i FROM 1 TO numofgroups
                RIGHT
                DITTO
            ENDFOR
            EXECUTE "MOVETO [" + fieldlabel + "]"
    ENDIF
    [] = targetvalue
    UPIMAGE
  ENDSCAN

   DO_IT!

   CLEARALL
   DELETE "$zzzxtab"
   RENAME "$$zzxtab" "Answer"

   IF (ISTABLE ("Struct"))
      THEN DELETE "Struct"
   ENDIF

   {Ask} {Answer} CHECKPLUS
   DO_IT!

ENDPROC                 					 ; End Transform ()


PROC Popup (boxwidth , numofitems)     ;  creates a box on the canvas

  leftedge = 79 - boxwidth
  topedge  = 22 - numofitems - 2

  menuname = " Calculation  Options "
  array menuitem [7]
  menuitem [1] = " 1. Group Total"
  menuitem [2] = " 2. Group Average"
  menuitem [3] = " 3. Count Entries in Group"
  menuitem [4] = " 4. Largest Entry in Group"
  menuitem [5] = " 5. Smallest Entry in Group"
  menuitem [6] = " 6. Leave Entries Unchanged"
  menuitem [7] = " 7. Make Your Own Calculation"

  @ topedge, leftedge ?? chr (201), fill (chr(205), 3), chr (185), menuname,
                         chr (204), fill (chr(205), 3), chr (187)
  style reverse
  @ topedge, leftedge + 5 ?? menuname
  style
  @ topedge + 1, leftedge            ?? chr(186)
  @ topedge + 1, leftedge + boxwidth ?? chr(186)

   for i from 1 to numofitems
       @ topedge + 1 + i,  leftedge             ?? chr (186), menuitem [i]
       @ topedge + 1 + i, (leftedge + boxwidth) ?? chr (186)
   endfor

   @ (topedge + numofitems + 2), leftedge ?? chr(200), fill (chr(205),
                                              boxwidth - 1), chr(188)

  @ 8, 0
  text
                                 
                                 
Move About the Pop-Up Menu:   -   -
       
                                 
Or:  [ Home ]   &   [ End ]


Or:  Type the number of your selection.


Make Selection:  [ Enter ]


Cancel Pop-Up Menu: [ Esc ]

  endtext

  current = 1

  while true
    style reverse        ;Highlight current selection
    drawpopup ()
    style
    char=getchar ()      ;Read character from keyboard
    switch
      case char = -72  or  char = -75 :          ; [Up] or [Left]
           drawpopup ()
           current = mod (current + numofitems - 2, numofitems) + 1
                                                 ;Move to next menu choice
      case char = -80  or  char = -77 :          ; [Down] or [Right]
           drawpopup ()
           current = mod (current, numofitems) + 1  ; Move to next menu choice
      case char = -71 :                          ; [Home]
           drawpopup()
           current = 1                           ; Move to next menu choice
      case char = -79 :                          ; [End]
           drawpopup()
           current = numofitems                  ; Move to next menu choice
      case char = 13  :                          ; [Enter]
           EnterCalc (current)                   ; Set current field to choice
           return                                ; and exit
      case char = 27  : [] = ""                  ; [Esc] => abort
           return
      case char = 49  : drawpopup()
                        current = 1
      case char = 50  : drawpopup()
                        current = 2
      case char = 51  : drawpopup()
                        current = 3
      case char = 52  : drawpopup()
                        current = 4
      case char = 53  : drawpopup()
                        current = 5
      case char = 54  : drawpopup()
                        current = 6
      case char = 55  : drawpopup()
                        current = 7
      OTHERWISE       : BEEP                               ; Illegal keys
    ENDSWITCH
   ENDWHILE
   ECHO NORMAL               ;Remove PAL canvas, leaving underlying workspace

ENDPROC   							 ; END Popup()


PROC DrawPopup ()    ; Called by Popup(), DrawPopup() positions the cursor and
					      ; redraws the current menu item in either reverse or
							; normal style.

   @ current + topedge + 1, leftedge + 1
   ?? menuitem [current] + spaces (30 - len (menuitem [current]))

ENDPROC								     ; End DrawPopup()


; called by popup() the following procedure -- entercalc (current) -- enters
; the calculation that corresponds to the selected item in the pop-up menu.

PROC EnterCalc (current)

  valfld = ""
  switch
    case current = 1 : [] = [] + ", calc sum"
    case current = 2 : [] = [] + ", calc average"
    case current = 3 : [] = [] + ", calc count"
    case current = 4 : [] = [] + ", calc max"
    case current = 5 : [] = [] + ", calc min"
    case current = 6 : if (version() > 2)
    			  then [] = [] + ", calc 1 * "
		       endif
		       ValFld = ValueField
    case current = 7 :
  ENDSWITCH
ENDPROC                          ; End EnterCalc (current)


PROC Qry (LabelField, ValueField)

  Msg ("Processing the cross-tab query", TRUE)
  DO_IT!

  IF (ISEMPTY ("Answer"))
     THEN QUIT "Resulting Answer table is empty.  Can't proceed with "  +
                                                   "cross tabulation!"
     ELSE RENAME "Answer"  "$zzzxtab"
          if (valfld <> valuefield)
             then down
                  left
                  valfld = field()
          endif
  endif

  clearall
  {Ask} select "$zzzxtab"
        execute "moveto [" + labelfield + "]"
        check
  Do_It!

  numoflabels = nrecords ("Answer")
  array label [numoflabels]
  execute "moveto [" + labelfield + "]"
  scan
    label [recno ()] = []
  endscan

  clearall
  create "$$zzxtab" like "$zzzxtab"
  menu {modify} {restructure} {$$zzxtab}
    scan for ([Field Name] = labelfield)
       Del
       scan for ([Field Name] = valfld)
            fldtype = [Field Type]
            Del
       endscan
       for i from 1 to numoflabels
           DOWN
           TYPEIN STRVAL (label [i])
           RIGHT
           TYPEIN FLDTYPE
       ENDFOR
       QUITLOOP
    ENDSCAN
  DO_IT!
  ENTER ENTER

ENDPROC									   ; End Qry (LabelField, ValueField)


CREATELIB SDIR() + "CrossTab"

WRITELIB  SDIR() + "CrossTab" Msg, Main, CrosstabSplashScreen, Help2,
										Startup, CleanField, FillInQry2,
										LabelFieldOK, UseSetup2,
										Transform, Popup, DrawPopup, EnterCalc, Qry
